<template>
    <div class="content-grid content-grid--subpage content-grid--subpage-table">
        <Breadcrumbs :title="t(`routes.admin.children.regles.name`)" />
        <div class="content-grid__header">
            <h1 class="back-link-title">{{ t(`routes.admin.children.regles.name`) }}</h1>
            <div class="content-grid__filters">
                <SearchInput v-model="searchValue" />
            </div>
        </div>
        <Card :title="t('global.quickLinks')">

            <div>
                <BtnLink :name="t('routes.admin.children.regles.add.name')"
                         :path="{ name: 'admin.children.regles.children.add' }" />
            </div>
            <div>
                <BtnLink :name="t('routes.regles.name')"
                         :path="{ name: 'regles' }" />
            </div>

        </Card>

        <Card>
            <DataTable :headers="regleHeader"
                       :search-value="searchValue"
                       :is-loading="enChargement"
                       :items="tableRegle"
                       @delete="deleteRegle" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
import i18n from "@/i18n";
import {useI18n} from "vue3-i18n";

import {computed, onMounted, ref} from "vue";
import {useRegleService} from "@/inversify.config";
import {notifyError, notifySuccess} from "@/notify";
import Card from "@/components/layout/Card.vue";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import SearchInput from "@/components/layout/SearchInput.vue";
import DataTable from "@/components/layout/DataTable.vue";
    import BtnLink from "@/components/layout/BtnLink.vue";
    import { Regle } from "@/types/entities";
import {Guid} from "@/types";

const {t} = useI18n()
const regleService = useRegleService()

    const lesRegles = ref<Regle[]>([]);
const searchValue = ref("");
const enChargement = ref(false);

const tableRegle = computed(() => {
    return lesRegles.value.map((x: Regle) => {
        if (x.descriptionFr!.length>20) {
            x.descriptionFr =`${ x.descriptionFr?.substring(0,20)} (...)`
        }     
        if (x.titreFr!.length > 20) {
            x.titreFr = `${x.titreFr?.substring(0, 20)} (...)`
        }  
        return {
            id: x.id,
            titre: (x.titreFr) ?? '',
            description: x.descriptionFr ?? "Vide",
            actions: {
                update: { name: `admin.children.regles.children.edit`, params: { id: x.id } },
                delete: true,
                view: { name: `admin.children.regles.children.visualiser`, params: { id: x.id } }
            }

    }
  }).sort((a: any, b: any) => {
    if (a.titre < b.titre) {
      return -1;
    }
    if (a.titre > b.titre) {
      return 1;
    }
      return 0;
  }) as Regle[];
})

onMounted(async () => {
  await chargerRegles();
});

async function chargerRegles() {
    enChargement.value = true;
    let regles = await regleService.getAllRegles();
    if (regles && regles.length > 0) {
        regles.forEach((x: Regle) => x.descriptionFr = x.descriptionFr?.replaceAll(/<[^>]+>/g, ""))
        lesRegles.value = regles;
  }
  enChargement.value = false;
}


    async function deleteRegle(regle: any) {
  if (regle?.id == null || !Guid.isValid(regle.id ?? ""))
    return

  let confirmDelete = confirm(t("validation.regle.delete.confirmation"));
  if (!confirmDelete)
    return;

  let response = await regleService.deleteRegle(regle.id)
  if (response.succeeded) {
    lesRegles.value = lesRegles.value.filter(x => x.id !== regle.id)
    notifySuccess(t('validation.regle.delete.success'))
  } else {
    let errorMessages = response.getErrorMessages('validation.regle.delete',
        'validation.regle.delete.errorOccured')
    notifyError(errorMessages[0])
  }
}

const regleHeader = [
  {
    text: t("regle.titre"),
    value: "titre",
    sortable: true,
    width: 300,
  },
  {
    text: t("regle.description"),
    value: "description",
    sortable: true,
      width: 150,
    
    },
    {
        text: t("global.table.actions"),
        value: "actions",
        width: 75
    },
];</script>